module IX07 (exp_out, exp_in, poly_in, length_in);
   output [06:00] exp_out;
   input [06:00]  exp_in, poly_in;
   input          length_in;

   assign exp_out[00] = (exp_in[00] & poly_in[06]) ^
                        (exp_in[01] & poly_in[05]) ^
                        (exp_in[02] & poly_in[04]) ^
                        (exp_in[03] & poly_in[03]) ^
                        (exp_in[04] & poly_in[02]) ^
                        (exp_in[05] & poly_in[01]) ^
                        (exp_in[06] & poly_in[00]) ^ length_in;
   
   assign exp_out[06:01] = exp_in[05:00];
endmodule

module IX15 (exp_out, exp_in, poly_in, length_in);
   output [14:00] exp_out;
   input [14:00]  exp_in, poly_in;
   input          length_in;

   assign exp_out[00] = (exp_in[00] & poly_in[14]) ^
                        (exp_in[01] & poly_in[13]) ^
                        (exp_in[02] & poly_in[12]) ^
                        (exp_in[03] & poly_in[11]) ^
                        (exp_in[04] & poly_in[10]) ^
                        (exp_in[05] & poly_in[09]) ^
                        (exp_in[06] & poly_in[08]) ^
                        (exp_in[07] & poly_in[07]) ^
                        (exp_in[08] & poly_in[06]) ^
                        (exp_in[09] & poly_in[05]) ^
                        (exp_in[10] & poly_in[04]) ^
                        (exp_in[11] & poly_in[03]) ^
                        (exp_in[12] & poly_in[02]) ^
                        (exp_in[13] & poly_in[01]) ^
                        (exp_in[14] & poly_in[00]) ^ length_in;

   assign exp_out[14:01] = exp_in[13:00];
endmodule

module IX23 (exp_out, exp_in, poly_in, length_in);
   output	[22:00]	exp_out;
   input 	[22:00]	exp_in, poly_in;
   input		length_in;

   assign exp_out[00] = (exp_in[00] & poly_in[22]) ^
                        (exp_in[01] & poly_in[21]) ^
                        (exp_in[02] & poly_in[20]) ^
                        (exp_in[03] & poly_in[19]) ^
                        (exp_in[04] & poly_in[18]) ^
                        (exp_in[05] & poly_in[17]) ^
                        (exp_in[06] & poly_in[16]) ^
                        (exp_in[07] & poly_in[15]) ^
                        (exp_in[08] & poly_in[14]) ^
                        (exp_in[09] & poly_in[13]) ^
                        (exp_in[10] & poly_in[12]) ^
                        (exp_in[11] & poly_in[11]) ^
                        (exp_in[12] & poly_in[10]) ^
                        (exp_in[13] & poly_in[09]) ^
                        (exp_in[14] & poly_in[08]) ^
                        (exp_in[15] & poly_in[07]) ^
                        (exp_in[16] & poly_in[06]) ^
                        (exp_in[17] & poly_in[05]) ^
                        (exp_in[18] & poly_in[04]) ^
                        (exp_in[19] & poly_in[03]) ^
                        (exp_in[20] & poly_in[02]) ^
                        (exp_in[21] & poly_in[01]) ^
                        (exp_in[22] & poly_in[00]) ^ length_in;


   assign exp_out[22:01] = exp_in[21:00];
endmodule

module IX29 (exp_out, exp_in, poly_in, length_in);
   output [28:00] exp_out;
   input [28:00]  exp_in, poly_in;
   input          length_in;

   assign exp_out[00] = (exp_in[00] & poly_in[28]) ^
                        (exp_in[01] & poly_in[27]) ^
                        (exp_in[02] & poly_in[26]) ^
                        (exp_in[03] & poly_in[25]) ^
                        (exp_in[04] & poly_in[24]) ^
                        (exp_in[05] & poly_in[23]) ^
                        (exp_in[06] & poly_in[22]) ^
                        (exp_in[07] & poly_in[21]) ^
                        (exp_in[08] & poly_in[20]) ^
                        (exp_in[09] & poly_in[19]) ^
                        (exp_in[10] & poly_in[18]) ^
                        (exp_in[11] & poly_in[17]) ^
                        (exp_in[12] & poly_in[16]) ^
                        (exp_in[13] & poly_in[15]) ^
                        (exp_in[14] & poly_in[14]) ^
                        (exp_in[15] & poly_in[13]) ^
                        (exp_in[16] & poly_in[12]) ^
                        (exp_in[17] & poly_in[11]) ^
                        (exp_in[18] & poly_in[10]) ^
                        (exp_in[19] & poly_in[09]) ^
                        (exp_in[20] & poly_in[08]) ^
                        (exp_in[21] & poly_in[07]) ^
                        (exp_in[22] & poly_in[06]) ^
                        (exp_in[23] & poly_in[05]) ^
                        (exp_in[24] & poly_in[04]) ^
                        (exp_in[25] & poly_in[03]) ^
                        (exp_in[26] & poly_in[02]) ^
                        (exp_in[27] & poly_in[01]) ^
                        (exp_in[28] & poly_in[00]) ^ length_in;

   assign exp_out[28:01] = exp_in[27:00];
endmodule