vlib work
vmap work work

vlog -work work ../../Hardware_Testbench/fifo_generator_v5_3.v

##Verilog Interface files
#vlog -work work ../../Design/Verilog/BUS_ALIGN_MACHINE.v
#vlog -work work ../../Design/Verilog/SDR_4TO1_16CHAN_TX.v
#vlog -work work ../../Design/Verilog/SDR_4TO1_16CHAN_RX.v

#VHDL Interface files
vcom -work work ../../Design/VHDL/count_to_128.vhd
vcom -work work ../../Design/VHDL/BUS_ALIGN_MACHINE.vhd
vcom -work work ../../Design/VHDL/SDR_4TO1_16CHAN_TX.vhd
vcom -work work ../../Design/VHDL/SDR_4TO1_16CHAN_RX.vhd

vlog -work work ../../Hardware_Testbench/IX.v
vlog -work work ../../Hardware_Testbench/COUNT_TO_16.v
vlog -work work ../../Hardware_Testbench/RST_MACHINE.v
vlog -work work ../../Hardware_Testbench/ERROR_DETECTOR.v
vlog -work work ../../Hardware_Testbench/SYSTEM_LOGIC.v
vlog -work work ../../Hardware_Testbench/PRBSGen.v
vlog -work work ../../Hardware_Testbench/PATTERN_GENERATOR.v
vlog -work work ../../Hardware_Testbench/SDR_4TO1_16CHAN_TOP.v
vlog -work work ../SDR_4TO1_16CHAN_TOP_TB.v

vlog -work work glbl.v

#Load the design. Use required libraries.#
vsim -t ps -novopt +notimingchecks -L unisims_ver -L secureip -L xilinxcorelib_ver work.SDR_4TO1_16CHAN_TOP_TB glbl

#View sim_tb_top signals in waveform#
do wave.do
run -all
